VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   2055
      Left            =   0
      ScaleHeight     =   1995
      ScaleWidth      =   2715
      TabIndex        =   0
      Top             =   0
      Width           =   2775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Drawing As Boolean
Private m_X1 As Single
Private m_Y1 As Single
Private m_X2 As Single
Private m_Y2 As Single

' Draw the shape in the area defined by the points
' (m_X1, m_Y1) and (m_X2, m_Y2).
Private Sub DrawShape()
Dim cx As Single
Dim cy As Single
Dim wid As Single
Dim hgt As Single
Dim radius As Single
Dim aspect As Single

    cx = (m_X1 + m_X2) / 2
    cy = (m_Y1 + m_Y2) / 2
    wid = Abs(m_X1 - m_X2) / 2
    hgt = Abs(m_Y1 - m_Y2) / 2
    If wid = 0 Or hgt = 0 Then Exit Sub

    If wid > hgt Then
        radius = wid
    Else
        radius = hgt
    End If
    aspect = hgt / wid

    picCanvas.Circle (cx, cy), radius, , , , aspect
End Sub

Private Sub Form_Load()
    picCanvas.AutoRedraw = True
    picCanvas.ForeColor = vbRed
End Sub

Private Sub Form_Resize()
    picCanvas.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


' Start drawing.
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button And vbRightButton Then
        ' It's the right button. Cancel the draw.
        If m_Drawing Then
            ' Erase the previous shape.
            DrawShape

            ' Stop drawing.
            m_Drawing = False
            picCanvas.DrawMode = vbCopyPen
            picCanvas.DrawStyle = vbSolid
        End If
    Else
        ' Start drawing.
        m_Drawing = True
        picCanvas.DrawMode = vbInvert
        picCanvas.DrawStyle = vbDot
        m_X1 = X
        m_Y1 = Y
        m_X2 = X
        m_Y2 = Y

        ' Draw the first shape.
        DrawShape
    End If
End Sub

' Continue drawing.
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if we're not drawing.
    If Not m_Drawing Then Exit Sub

    ' Erase the previous shape.
    DrawShape

    ' Save the new point.
    m_X2 = X
    m_Y2 = Y

    ' Draw the new shape.
    DrawShape
End Sub


' Finish drawing.
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if we're not drawing.
    If Not m_Drawing Then Exit Sub

    ' Erase the previous shape.
    DrawShape

    ' Stop drawing.
    m_Drawing = False
    picCanvas.DrawMode = vbCopyPen
    picCanvas.DrawStyle = vbSolid

    ' Save the new point.
    m_X2 = X
    m_Y2 = Y

    ' Make the shape permenant. This might involve
    ' saving coordinates to a database or something.
    ' In this case, it just means redrawing the
    ' shape in non-invert mode.
    DrawShape
End Sub
